sub EncodeFile
{
if ( -d $ENV{"PATH_TRANSLATED"} )
  { $pagefile = $ENV{"PATH_TRANSLATED"};
    if ( $pagefile =~ /[^@@dirdelim@@]$/ )
      { $pagefile .= "@@dirdelim@@"; }
    $pagefile .= "@@defaultfile@@"; }
 else
  { $pagefile = $ENV{"PATH_TRANSLATED"}; }

($ext) = $pagefile =~ m/.*\.([^.]*)$/;

if (  $mime{$ext}  )
  { if ( open ( HTML, $pagefile ) )
      {
        &MakeHeaders;

        while ( <HTML> )
          {
            &EncodeLine;
            print $_;
          }
        close ( HTML );
      }
     else
      { print "Status: 404 Not Found\n";
        print "Content-type: text/html\n\n";
        print "Document not found. Please check the URL.\n"; }
  }
else
  { print "Status: 301 Moved permanently\n";
    print "Location: http://",$ENV{"SERVER_NAME"},$ENV{"PATH_INFO"},"\n\n"; }
}


sub MakeHeaders {
@@@ if timeservices
  local ( $dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size,
          $atime, $mtime, $ctime, $blksize, $blocks ) = stat HTML;
  local ( $sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst )
          = localtime ( $mtime );
  local ( $dayname ) = (Sun,Mon,Tue,Wed,Thu,Fri,Sat)[$wday];
  local ( $monname ) = (Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec)[$mon];
  if ( $year > 70 )
    { $year += 1900; }
   else
    { $year += 2000; }
  local ( $imtime, $mytime );

@@@ if ifmodifiedsince
  if ( $ENV{"HTTP_IF_MODIFIED_SINCE"} )
    { $imtime = &ConvertTime ( $ENV{"HTTP_IF_MODIFIED_SINCE"} );
      $mytime = sprintf ( "%d %02d %02d %02d:%02d:%02d",
                           $year, $mon, $mday, $hour, $min, $sec );
      if ( $mytime le $imtime )
        { print "Status: 304 Not modified\n\n";
          exit ( 0 ); }
    }
@@@ endif
@@@ endif
  print "Content-Type: $mime{$ext}\n";
@@@ if timeservices
  print "Content-Length: $size\n";
  printf "Last-Modified: %s, %02d %s %d %02d:%02d:%02d GMT\n",
          $dayname, $mday, $monname, $year, $hour, $min, $sec;
@@@ endif
  print "\n";
}


sub ConvertTime {
  local ( $time ) = @_;
  local ( $finaltime, $h, $d, $m, $y );

$mnum{"jan"} =  1; $mnum{"may"} =  5; $mnum{"sep"} =  9;
$mnum{"feb"} =  2; $mnum{"jun"} =  6; $mnum{"oct"} = 10;
$mnum{"mar"} =  3; $mnum{"jul"} =  7; $mnum{"nov"} = 11;
$mnum{"apr"} =  4; $mnum{"aug"} =  8; $mnum{"dec"} = 12;

  if ( $time =~ /^...,/ )
    { ($d,$m,$y,$h) = $time =~ m/^...,\s+(\d+)\s+(\S+)\s+(\d+)\s+(\S+)/;
      $m =~ tr/A-Z/a-z/;
      $m = $mnum{$m};
      $finaltime = sprintf ( "%d %02d %02d %s", $y, $m, $d, $h );
    }
  elsif ( $time =~ /^...\s/ )
    { ($m,$d,$h,$y) = $time =~ m/^...\s+(\S+)\s+(\d+)\s+(\S+)\s+(\d+)/;
      $m =~ tr/A-Z/a-z/;
      $m = $mnum{$m};
      $finaltime = sprintf ( "%d %02d %02d %s", $y, $m, $d, $h );
    }
  elsif ( $time =~ /^\S+,/ )
    { ($d,$m,$y,$h) = $time =~ m/^\S+,\s+(\d+)-(\w+)-(\d+) (\S+)/;
      if ( $y > 70 ) 
        { $y += 1900; }
       else
        { $y += 2000; }
      $m =~ tr/A-Z/a-z/;
      $m = $mnum{$m};
      $finaltime = sprintf ( "%d %02d %02d %s", $y, $m, $d, $h );
    }
  else { $finaltime = ""; }

$finaltime;
}


